<template>
	<xn-form-container
		:title="formData.id ? '编辑成功案例' : '增加成功案例'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-row :gutter="16">
				<a-col :span="12">
					<a-form-item label="案例名称：" name="name">
						<a-input v-model:value="formData.name" placeholder="请输入案例名称" allow-clear/>
					</a-form-item>
				</a-col>

				<a-col :span="12">
					<a-form-item label="产品图片：" name="pic">
						<Upload ref="uploadPicRef" :upload-mode="'pic'"
								:upload-number="1" @uploadDone="uploadPicDone"/>
					</a-form-item>
				</a-col>

				<a-col :span="12">
					<a-form-item label="排序：" name="sort">
						<a-input-number v-model:value="formData.sort" placeholder="请输入排序"
										style="width: 100%;" :min="1" :max="1000"/>
					</a-form-item>
				</a-col>

				<a-col :span="12">
					<a-form-item label="案例类型" name="typeId">
						<a-select v-model:value="formData.typeId" :options="caseTypeData"
								  placeholder="请选择案例类型"/>
					</a-form-item>
				</a-col>

				<a-col :span="18">
					<a-form-item label="案例描述：" name="remark">
						<a-textarea v-model:value="formData.remark" placeholder="请输入案例描述"
									:auto-size="{ minRows: 3, maxRows: 4 }"/>
					</a-form-item>
				</a-col>
			</a-row>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="caseForm">

import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import caseApi from '@/api/website/caseApi'
import caseTypeApi from '@/api/website/caseTypeApi'
import Upload from "@/components/XnUpload/index.vue";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
const uploadPicRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
		// 处理图片
		initFiles(record)
	}
	initCaseType()
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	name: [required('请输入案例名称')],
	pic: [required("请上传案例图片")],
	sort: [required("请输入排序")],
	typeId: [required("请选择案例类型")],
	remark: [required("请输入案例描述")],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value.validate().then(() => {
		submitLoading.value = true
		const formDataParam = cloneDeep(formData.value)
		caseApi.save(formDataParam, formDataParam.id)
			.then(() => {
				onClose()
				emit('successful')
			})
			.finally(() => {
				submitLoading.value = false
			})
	})
}
// 图片上传
const uploadPicDone = (data) => {
	if (data.length > 0) {
		formData.value.pic = data[0].url
	} else {
		formData.value.pic = null
	}
}
// 处理图片
const initFiles = (record) => {
	let pics = []
	if (record.pic) {
		pics.push({url: record.pic})
	}
	nextTick(() => {
		uploadPicRef.value.setFileList(pics)
	})
}

// 初始化案例类型
const caseTypeData = ref([])
const initCaseType = () => {
	caseTypeApi.list({}).then(res => {
		caseTypeData.value = res.map(x => {
			return {label: x.name, value: x.id}
		})
	})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
